/**************************************************************************/
/*                                                                        */
/*  Thibaut Balabonski, Sylvain Conchon, Jean-Christophe Filliâtre,       */
/*  Kim Nguyen, Laurent Sartre                                            */
/*                                                                        */
/*  Informatique - MP2I/MPI - CPGE 1re et 2e années.                      */
/*  Cours et exercices corrigés. Éditions Ellipses, 2022.                 */
/*                                                                        */
/*  https://www.informatique-mpi.fr/                                      */
/*                                                                        */
/**************************************************************************/

#include "prelude.h"
#include "selection_sort.h"

// tri par sélection

void selection_sort(int a[], int n) {
  for (int i = 0; i < n - 1; i++) {
    int j_min = i;
    for (int j = i + 1; j < n; j++) {
      if (a[j] < a[j_min]) { j_min = j; }
    }
    int v = a[j_min];
    a[j_min] = a[i];
    a[i] = v;
  }
}

// tri par sélection adapté à des paires (clé, données)

struct Data {
  int key;
  char *contents;
};

void swap_data(data *a, int i, int j) {
  data tmp = a[i];
  a[i] = a[j];
  a[j] = tmp;
}

int select_min(data *a, int lo, int hi) {
  assert (lo < hi);
  int i_min = lo;
  for (int i = lo + 1; i < hi; i++) {
    if (a[i].key < a[i_min].key) { i_min = i; }
  }
  return i_min;
}

void selection_sort_data(data *a, int n) {
  for (int i = 0; i < n; i++) {
    int j = select_min(a, i, n);
    swap_data(a, i, j);
  }
}
